/*
 * File: app/view/addProcesForm.js
 *
 * This file was generated by Sencha Architect version 2.0.0.
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Sencha Touch 2.0.x library, under independent license.
 * License of Sencha Architect does not include license for Sencha Touch 2.0.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('PFC.view.addProcesForm', {
    extend: 'Ext.form.Panel',
    alias: 'widget.addprocesform',

    config: {
        id: 'addProcesForm',
        itemId: 'addProcesForm',
        layout: {
            pack: 'center',
            type: 'vbox'
        },
        scrollable: 'vertical',
        items: [
            {
                xtype: 'fieldset',
                id: 'formulariProces',
                itemId: 'myfieldset1',
                title: 'Afegir un nou procés',
                items: [
                    {
                        xtype: 'textfield',
                        label: 'Nom',
                        name: 'nom',
                        required: true
                    },
                    {
                        xtype: 'textareafield',
                        label: 'Descripció',
                        name: 'descripcio'
                    }
                ]
            },
            {
                xtype: 'button',
                itemId: 'submit',
                ui: 'confirm-round',
                iconCls: 'add',
                iconMask: true,
                text: 'Crea'
            }
        ],
        listeners: [
            {
                fn: 'onSubmitTap',
                event: 'tap',
                delegate: '#submit'
            },
            {
                fn: 'onAddProcesFormInitialize',
                event: 'initialize'
            }
        ]
    },

    onSubmitTap: function(button, e, options) {
        Ext.getStore('procesJson').clearFilter();
        var form = button.up('addprocesform'),
        mainPanel = form.up('#mainPanel'),
        store = mainPanel.down('#procesosList').getStore(),
        procesRecord = form.getValues();

        if (!PFC.novaId){
            PFC.novaId=Ext.getStore('procesJson').max('id')+1;
        }else{
            PFC.novaId=PFC.novaId+1;
        }

        if (procesRecord.nom!==""){
            if (procesRecord.Etiqueta!==null){
                var etiquetes = [];
                var i=0, aux;
                for (i===0;i<procesRecord.Etiqueta.length;i++){
                    if (procesRecord.Etiqueta[i]!==null) etiquetes.push(procesRecord.Etiqueta[i]);
                }

                //Store to local storage and sync to remote syncstorage
                procesRecord.id=PFC.novaId;
                store.add(procesRecord);
                //store.last.id=PFC.novaId;
                //-------store.sync();

                //Associem el nou procés a les etiquetes seleccionades
                Ext.getStore('associatJson').clearFilter();
                i=0;
                for (i===0;i<etiquetes.length;i++){
                    aux =Ext.create('PFC.model.associat',{
                        proces_id: PFC.novaId, 
                        etiqueta_id: etiquetes[i]
                    });
                    Ext.getStore('associatJson').add(aux);
                }


                form.reset();
                Ext.getCmp('procesosList').deselectAll();

                Ext.getCmp('mainPanel').animateTo('right');
                Ext.getCmp('listPanel').setHidden(false);
                Ext.getCmp('usuariPanel').setHidden(false);
                Ext.getCmp('torna').setHidden(true);
                PFC.titol = "Processos de treball";
                Ext.getCmp('loggedInUserName').setTitle(PFC.titol);
                Ext.getStore('procesJson').clearFilter();
                Ext.getStore('etiquetaJson').clearFilter();
                Ext.getStore('etiquetaTipusJson').clearFilter();
                Ext.getStore('associatJson').clearFilter();

                Ext.getCmp('finestra').removeAt(2);
            }else{
                Ext.Msg.alert('Atenció!!',"Ha de seleccionar com a mínim una etiqueta per al nou procés.");
            }
        }else{
            Ext.Msg.alert('Atenció!!',"Ha d'omplenar el nom del procés.");
        }


    },

    onAddProcesFormInitialize: function(component, options) {
        //Cerquem les diferents etiquetes 
        var myPanel = Ext.create('Ext.Label', {html: '<br/><b>Etiquetes:</b><br/><br/>', style:'background-color:#FFEFD5'});
        Ext.getCmp('formulariProces').add([myPanel]);

        Ext.getStore('etiquetaJson').clearFilter();
        Ext.getStore('etiquetaTipusJson').clearFilter();

        var i = 0;
        for (i===0;i<Ext.getStore('etiquetaTipusJson').getCount();i++){
            var etiquetaV = Ext.create('Ext.Label', {
                html: Ext.getStore('etiquetaTipusJson').getAt(i).get('nom'),
                style:'background-color:#FFEFD5'
            });
            Ext.getCmp('formulariProces').add([etiquetaV]);

            //Filtrem els tipus d'etiqueta

            Ext.getStore('etiquetaJson').filter('etiquetaTipus_id',Ext.getStore('etiquetaTipusJson').getAt(i).get('id'));

            var j=0;
            for (j===0;j<Ext.getStore('etiquetaJson').getCount();j++){
                var etiquetaV2 = Ext.create('Ext.field.Checkbox', {
                    xtype: 'checkboxfield',
                    label: Ext.getStore('etiquetaJson').getAt(j).get('nom'),
                    labelWrap:true,
                    name:"Etiqueta",
                    value:Ext.getStore('etiquetaJson').getAt(j).get('id'),
                    labelWidth:'80%'
                });
                Ext.getCmp('formulariProces').add([etiquetaV2]);

            }
            //Esborrem el filtre per a que continui creant checkbox
            Ext.getStore('etiquetaJson').clearFilter();
        }
    }

});