/*
 * File: app/view/detailPanel.js
 *
 * This file was generated by Sencha Architect version 2.0.0.
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Sencha Touch 2.0.x library, under independent license.
 * License of Sencha Architect does not include license for Sencha Touch 2.0.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('PFC.view.detailPanel', {
    extend: 'Ext.Panel',

    config: {
        id: 'detailPanel',
        layout: {
            type: 'vbox'
        },
        items: [
            {
                xtype: 'container',
                id: 'procesPanel',
                itemId: 'procesPanel',
                style: 'background-color:#D7C663',
                tpl: [
                    '</br>',
                    '<b>Nom:</b> {nom}</br>',
                    '<b>Descripció:</b> {descripcio}'
                ],
                ui: '',
                flex: 0
            },
            {
                xtype: 'list',
                id: 'instruccioList',
                itemId: 'instruccioList',
                style: 'background-color:#FFEFD5',
                itemTpl: [
                    '<table width=\'100%\'>',
                    '<tr>',
                    '<td>{descripcio}</td>',
                    '<td width=\'50px\'><img id=\'img{id}\' src=\'touch/resources/images/imatge.png\' width=\'50px\' height=\'50px\'/></td>',
                    '</tr>',
                    '</table>'
                ],
                store: 'instruccioJson',
                flex: 2
            },
            {
                xtype: 'toolbar',
                docked: 'bottom',
                id: 'barraInstruccio',
                itemId: 'barraInstruccio',
                items: [
                    {
                        xtype: 'button',
                        id: 'novaInstruccio',
                        itemId: 'mybutton3',
                        ui: 'action-round',
                        iconCls: 'add',
                        iconMask: true,
                        text: 'Nova Instrucció',
                        flex: 1
                    },
                    {
                        xtype: 'button',
                        id: 'borraProces',
                        itemId: 'borraProces',
                        ui: 'decline-round',
                        iconCls: 'delete',
                        iconMask: true,
                        text: 'Esborra Procés',
                        flex: 1
                    }
                ]
            }
        ],
        listeners: [
            {
                fn: 'onInstruccioListItemTap',
                event: 'itemtap',
                delegate: '#instruccioList'
            },
            {
                fn: 'onNovaInstruccioTap',
                event: 'tap',
                delegate: '#novaInstruccio'
            },
            {
                fn: 'onBorraProcesTap',
                event: 'tap',
                delegate: '#borraProces'
            }
        ]
    },

    onInstruccioListItemTap: function(dataview, index, target, record, e, options) {
        Ext.getCmp('detailPanel').setHidden(true);
        Ext.getCmp('torna').setHidden(false);
        PFC.titol="Imatge id:"+record.get('id');
        Ext.getCmp('loggedInUserName').setTitle(PFC.titol);

        var foto = Ext.getCmp('Picture');

        if (foto) {
            Ext.getCmp('finestra').setActiveItem(foto);
        } else {
            Ext.getCmp('finestra').setActiveItem({xclass: 'PFC.view.Picture'});
        }

        Ext.getCmp('pictureDetall').setRecord(record);
        PFC.instruccio=record.get("id");

        if (PFC.tipus) {
            Ext.getCmp('barraSubinstruccio').setHidden(false);
        }
    },

    onNovaInstruccioTap: function(button, e, options) {

        Ext.getCmp('detailPanel').setHidden(true);
        Ext.getCmp('torna').setHidden(false);
        PFC.titol="Nova instrucció";
        Ext.getCmp('loggedInUserName').setTitle(PFC.titol);


        Ext.getCmp('finestra').setActiveItem({
            xclass: 'PFC.view.addInstruccioForm'
        });

        Ext.getCmp('proces_id').setValue(PFC.procesId);
    },

    onBorraProcesTap: function(button, e, options) {
        Ext.Msg.confirm(
        "Confirmació d'esborrat de Procés", "Esteu segurs que voleu esborrar aquest procés?", 
        function ( answer ) { 
            if ( answer == 'yes') {           
                //Esborrem l'associació d'etiquetes del JSON
                do{
                    Ext.getStore('associatJson').removeAt(Ext.getStore('associatJson').find('proces_id',PFC.procesId)); 
                }while (Ext.getStore('associatJson').find('proces_id',PFC.procesId)!=-1);

                //Esborrem el procés del JSON
                Ext.getStore('procesJson').removeAt(Ext.getStore('procesJson').find('id',PFC.procesId)); 

                PFC.titol="Processos de treball";
                Ext.getCmp('mainPanel').animateTo('right');
                Ext.getCmp('listPanel').setHidden(false);
                Ext.getCmp('usuariPanel').setHidden(false);
                Ext.getCmp('torna').setHidden(true);

                Ext.getCmp('finestra').removeAt(2);
                Ext.getStore('instruccioJson').clearFilter();

                PFC.titolAux="";
                PFC.procesId=0;
            } 
        }
        );
    }

});